--[[
straight left (varrying speeds!)
following sin circle while moving left
 (sin(time) * radius + time * some constant to keep moving left at certain speed)

groupings? rapid uniform group (2 or 3 or 6 or something)
rapid random assortment
slow predictable top and bottom
]]
local lg = love.graphics

local defaultSpeed = 960/3

local cron = require "lib.cron"
local Bullet = require "Bullet"

local function Enemy(bullets, x, y, w, h, color, update)
    self = {}

    self.w = w or 10
    self.h = h or 10

    self.x = x or lg.getWidth() + self.w
    self.y = y or lg.getHeight() / 2

    self.color = color or {255, 0, 0}

    local fire = cron.every(1/12, function()
        print("Fired bullet")
        table.insert(bullets, Bullet(self.x, self.y, false, false, false, {255, 0, 0}))
    end)

    --[[self.update = update or function(self, dt)
        self.x = self.x - defaultSpeed * dt
        fire:update(dt)
        print("What?")
    end]]
    self.update = function(self, dt)
        if update then
            update(self, dt)
        else
            self.x = self.x - defaultSpeed * dt
        end
        fire:update(dt)
    end

    --[[self.fire = function(self, dt)
        crony:update(dt)
    end]]

    return self
end

local function EnemyGroup(bullets, enemiesTable, enemyType, movementType, placement, amount)
    if not enemiesTable then
        enemiesTable = {}
    end
    if not amount or amount == "random" then
        if placement == "random" then
            amount = math.random(1, 3)
        elseif placement == "chain" then
            amount = math.random(1, 9)
        end
    end
    for i=1,amount do
        local x = false
        local y = false
        local w = false
        local h = false
        local color = false
        local update = false
        --[[
        if enemyType == "something" then
            -- do something
        end
        --]]
        if movementType == "randomSpeed" then
            local speed = math.random(defaultSpeed / 2, defaultSpeed * 2)
            update = function(self, dt)
                self.x = self.x - speed * dt
            end
        end
        if placement == "random" then
            x = math.random(lg.getWidth() + 5, lg.getWidth() + 5 * 10)
            y = math.random(5, lg.getHeight() - 5)
        end
        --table.insert stuff
        table.insert(enemiesTable, Enemy(bullets, x, y, w, h, color, update))
    end
    --[[
    EnemyGroup creates groups, based on a movement type (straight movement, sin movement, others),
                                        a placement (duo top/bottom, center, random),
                                        a number (random, specified) <- how many to spawn,
                                        a enemy type (right now just one type)
    ]]

    return enemiesTable
end

return {
    CreateEnemy = Enemy,
    CreateEnemyGroup = EnemyGroup
}
